'***************** (c) 2007 BTC Korporacja ***********************************
'                     http://www kamami.com
'PROJECT  : LED_7S
'BOARD    : ZL10AVR v.3 (with ATmega32 in socket U2)
'COMPILER : BASCOM AVR
'
'******************************************************************************
'
'    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
'    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
'    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
'    FROM USE OF THIS SOFTWARE.
'
'******************************************************************************
'
'DESCRIPTION :
'    Simple 7 segment LED display demonstration.
'
'    Jumpers settings on ZL10AVR:
'        JP11 - 2-3 (=OFF) <- U1 GRES  (general reset)
'        JP9  - 2-3 (=OFF) <- U1 CRYST (crystal)
'        JP10 - 2-3 (=OFF) <- U1 CRYST (crystal)
'        JP5  - 2-3 (=OFF) <- U4 CRYST (crystal)
'        JP6  - 2-3 (=OFF) <- U4 CRYST (crystal)
'        JP7  - 2-3 (=OFF) <- U4 GRES  (general reset)
'        JP2  - 2-3 (=OFF) <- U5 CRYST (crystal)
'        JP3  - 2-3 (=OFF) <- U5 CRYST (crystal)
'        JP4  - 2-3 (=OFF) <- U5 GRES  (general reset)
'        JP1  - 2-3 (=OFF) <- U7 GRES  (general reset)
'        JP21 - 2-3 (=U2/3/5/6) <- active socket (ATmega32 in U2 socket)
'
'
'        S2.1 - ON <- turn on display DS4
'        S2.2 - ON <- turn on display DS3
'        S2.3 - ON <- turn on display DS2
'        S2.4 - ON <- turn on display DS1
'        JP17 - 1-2 (=PA) <- segments connected to port PA
'
'******************************************************************************

$regfile = "m32def.dat"
$crystal = 8000000                                          '8 MHz - turn on external resonator (fuse bits)
$baud = 1200
$hwstack = 64
$swstack = 64
$framesize = 64

Dim Temp As Byte

Config Porta = Output
Config Portb = Output

' PA - segments
Led7 Alias Porta

' PB0...3 - displays
Ds4 Alias Portb.0
Ds3 Alias Portb.1
Ds2 Alias Portb.2
Ds1 Alias Portb.3

Do
  ' all segments on
  Led7 = 255
  Portb = 255
  Waitms 500

  ' display DS4
  Set DS4 : Reset DS3 : Reset DS2 : Reset DS1
  For Temp = 0 To 9
    Led7 = Lookup(temp , Led7s_table)
    Waitms 300
  Next Temp

  ' display DS3
  Reset DS4 : Set DS3 : Reset DS2 : Reset DS1
  For Temp = 0 To 9
    Led7 = Lookup(temp , Led7s_table)
    Waitms 300
  Next Temp

  ' display DS2
  Reset DS4 : Reset DS3 : Set DS2 : Reset DS1
  For Temp = 0 To 9
    Led7 = Lookup(temp , Led7s_table)
    Waitms 300
  Next Temp

  ' display DS1
  Reset DS4 : Reset DS3 : Reset DS2 : Set DS1
  For Temp = 0 To 9
    Led7 = Lookup(temp , Led7s_table)
    Waitms 300
  Next Temp

Loop
End

Led7s_table:
Data 63 , 6 , 91 , 79 , 102 , 109 , 125 , 7 , 127 , 111