'***************** (c) 2007 BTC Korporacja ***********************************
'                     http://www kamami.com
'PROJECT  : RC5
'BOARD    : ZL10AVR v.3 (with ATmega32 in socket U2)
'COMPILER : BASCOM AVR
'
'******************************************************************************
'
'    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
'    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
'    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
'    FROM USE OF THIS SOFTWARE.
'
'******************************************************************************
'
'DESCRIPTION :
'    Retrieves the RC5 remote code from a IR transmitter.
'
'    Jumpers settings on ZL10AVR:
'        JP11 - 2-3 (=OFF) <- U1 GRES  (general reset)
'        JP9  - 2-3 (=OFF) <- U1 CRYST (crystal)
'        JP10 - 2-3 (=OFF) <- U1 CRYST (crystal)
'        JP5  - 2-3 (=OFF) <- U4 CRYST (crystal)
'        JP6  - 2-3 (=OFF) <- U4 CRYST (crystal)
'        JP7  - 2-3 (=OFF) <- U4 GRES  (general reset)
'        JP2  - 2-3 (=OFF) <- U5 CRYST (crystal)
'        JP3  - 2-3 (=OFF) <- U5 CRYST (crystal)
'        JP4  - 2-3 (=OFF) <- U5 GRES  (general reset)
'        JP1  - 2-3 (=OFF) <- U7 GRES  (general reset)
'        JP21 - 2-3 (=U2/3/5/6) <- active socket (ATmega32 in U2 socket)
'
'        JP19 - 1-2 (=ON)  <- connect output from U12 (TSO1736)...
'        JP20 - 1-2 (=PB6) <- ... to line PB6
'
'******************************************************************************

$regfile = "m32def.dat"
$crystal = 8000000                                          '8 MHz - turn on external resonator (fuse bits)
$baud = 1200
$hwstack = 64
$swstack = 64
$framesize = 64

Dim Address As Byte , Command As Byte

Config Portb = Output
Config Portd = Output

Config Rc5 = Pinb.6
Config Pinb.6 = Input

Config Lcd = 16 * 2
Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portb.2 , Rs = Portb.0

Initlcd : Cls : Cursor Off
Lcd "  ZL10AVR v.3"
Lowerline
Lcd "RC5 Test"

Waitms 250

Enable Interrupts

Do
  Getrc5(address , Command)
  Command = Command And &B01111111
  If Address <> 255 Then
    Home
    Lcd "Address: " ; Address
    Lowerline
    Lcd "Command: " ; Command
  Else
    Home
    Lcd "Address: ???    "
    Lowerline
    Lcd "Command: ???    "
  End If
  Waitms 250
Loop

End