'***************** (c) 2007 BTC Korporacja ***********************************
'                     http://www kamami.com
'PROJECT  : UART
'BOARD    : ZL10AVR v.3 (with ATmega32 in socket U2)
'COMPILER : BASCOM AVR
'
'******************************************************************************
'
'    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
'    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
'    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
'    FROM USE OF THIS SOFTWARE.
'
'******************************************************************************
'
'DESCRIPTION :
'    Simple UART communication demo.
'
'    Jumpers settings on ZL10AVR:
'        JP11 - 2-3 (=OFF) <- U1 GRES  (general reset)
'        JP9  - 2-3 (=OFF) <- U1 CRYST (crystal)
'        JP10 - 2-3 (=OFF) <- U1 CRYST (crystal)
'        JP5  - 2-3 (=OFF) <- U4 CRYST (crystal)
'        JP6  - 2-3 (=OFF) <- U4 CRYST (crystal)
'        JP7  - 2-3 (=OFF) <- U4 GRES  (general reset)
'        JP2  - 2-3 (=OFF) <- U5 CRYST (crystal)
'        JP3  - 2-3 (=OFF) <- U5 CRYST (crystal)
'        JP4  - 2-3 (=OFF) <- U5 GRES  (general reset)
'        JP1  - 2-3 (=OFF) <- U7 GRES  (general reset)
'        JP21 - 2-3 (=U2/3/5/6) <- active socket (ATmega32 in U2 socket)
'
'        JP14 - 2-3 (=Tx ON)
'        JP13 - 2-3 (=Rx ON)
'        JP12 - 1-2 (=232) if RS232 cable connected
'             - 2-3 (=USB) if ZL1USB_A connected
'        JP8  - 1-2 (=232) if RS232 cable connected
'             - 2-3 (=USB) if ZL1USB_A connected
'
'    LCD connection
'        LCD - IO Line
'        DB4 - PD.4
'        DB5 - PD.5
'        DB6 - PD.6
'        DB7 - PD.7
'        E   - PB.2
'        RS  - PB.0
'
'******************************************************************************

$regfile = "m32def.dat"
$crystal = 8000000                                          '8 MHz - turn on external resonator (fuse bits)
$baud = 1200
$hwstack = 64
$swstack = 64
$framesize = 64

Dim Message As String * 16

Config Portb = Output
Config Portd = Output
Config Lcd = 16 * 2
Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portb.2 , Rs = Portb.0

Initlcd
Cls
Cursor Off
Lcd "ZL10AVR v.3 UART"
Lowerline
Lcd " www.kamami.com"

Print "*************************"
Print "**   ZL10AVR v.3 UART  **"
Print "**    www.kamami.com   **"
Print "*************************"

Do
  Input "->" , Message                                      'send prompt to terminal
  Cls
  Lcd "Rx:"
  Lowerline
  Lcd Message                                               'write received message on LCD
  Print "<-" ; Message
Loop

End